'
' MathSurface
'
' by Bean
' Jun20,2001
' Email:puzdtwvfg4@sohu.com
'
' Description:
' This is a math surface drawing program. The function DrawSurface is the core.
' By it, some surface can be shown easily. The surface should be given in the
' form of dual parametic equation. ( x=x(u,v),y=y(u,v),z=z(u,v) )
'
' I think it's really poor. I will improve it later. It's simple and no hard
' to understand.
'
' If you want to use or modifie these codes, please refer me and email your
' program to me if possible. For information and questions, please feel free
' to contact me.
'
DECLARE SUB SetOrigin (Hor AS INTEGER, Ver AS INTEGER)
DECLARE SUB SetDivideN (n1 AS INTEGER, n2 AS INTEGER)
DECLARE SUB SetProportion (x AS SINGLE, y AS SINGLE, z AS SINGLE)
DECLARE SUB DrawSurface (U1 AS SINGLE, U2 AS SINGLE, V1 AS SINGLE, V2 AS SINGLE)
DECLARE SUB DrawAxis (XLenth AS INTEGER, YLenth AS INTEGER, ZLenth AS INTEGER)
DECLARE SUB DrawKent (x1 AS INTEGER, x2 AS INTEGER, y1 AS INTEGER, y2 AS INTEGER, Angle AS SINGLE)
DECLARE SUB Delay ()
DECLARE SUB PrintText (x AS INTEGER, y AS INTEGER, str AS STRING)
'The surface was given by 3 functions below.
DECLARE FUNCTION FunctionX (u AS SINGLE, v AS SINGLE)
DECLARE FUNCTION FunctionY (u AS SINGLE, v AS SINGLE)
DECLARE FUNCTION FunctionZ (u AS SINGLE, v AS SINGLE)

TYPE OriginLocation
  Hor AS INTEGER
  Ver AS INTEGER
END TYPE

TYPE Proportion
  xk AS SINGLE
  yk AS SINGLE
  zk AS SINGLE
END TYPE

TYPE Coordinate
  x AS INTEGER
  y AS INTEGER
END TYPE

DIM Origin AS OriginLocation                  'The coordinate of the origin
DIM k AS Proportion                           'A shared variable to adjust the size
DIM UDivideN, VDivideN AS INTEGER             'Shared variables to adjust step
DIM FunN AS INTEGER                           'A shared variable to select surface

'Variables used by demo programs
DIM n1, n2 AS INTEGER
DIM Ox, Oy AS INTEGER
DIM xl, yl, zl AS INTEGER
DIM du, dv AS SINGLE
DIM ub, ue, vb, ve AS SINGLE

'Begin demo
COLOR 10
PrintText 13, 31, "Math Surface Demo"
COLOR 9
PrintText 25, 28, "Anykey key to continue..."
Delay

SCREEN 12

'Set the line 1-5 was the viewport
VIEW PRINT 1 TO 5

FOR n1 = 1 TO 6
  IF n1 = 3 OR n1 = 4 OR n1 = 5 OR n1 = 6 THEN CLS
  COLOR 15
  FOR n2 = 1 TO 3
    READ sentence$
    PRINT sentence$
  NEXT n2
  READ FunN, Ox, Oy, xl, yl, zl, du, dv, kx, ky, kz, ub, ue, vb, ve
  SetOrigin INT(Ox), INT(Oy)                       '
  COLOR 15                                         '
  DrawAxis INT(xl), INT(yl), INT(zl)               ' There still be a problem.To be solved.
  SetDivideN INT(du), INT(dv)                      '
  SetProportion kx, ky, kz
  COLOR 10
  DrawSurface ub, ue, vb, ve
  COLOR 9
  PRINT "Any key to next surface..."
  Delay
  CLS 2
NEXT n1
SCREEN 0
PrintText 1, 1, "Bye,have a try on DrawSurface!"

'Datas givin to demo program and surface
DATA "First,a flat was given in the form of x=u,y=u,z=0"
DATA "So,if you want to draw z=f(x,y),change it to x=u,y=u,z=f(x(u,v),y(u,v))"
DATA "Next,let's show x=x(u,v),y=y(u,v),z=z(u,v) and move origin."
DATA 1,    150,200,  100,100,100,  15,15, 10,10,10, -8, 8,-8, 8
'    -     -------   -----------   -----  --------  -------------
'    ^     Ox  Oy    xl  yl  zl    du dv  kx ky kz  ub ue vb ve
'    |     ^   ^     ^   ^   ^     ^  ^   ^  ^  ^   ^  ^  ^  ^  +---u,v from ub,vb
'    |     |   |     |   |   |     |  |   |  |  |   |  |  |  |  |   to ue,ve
'    |     +---+     +---+---+     +--+   +--+--+   +--+--+--+--+
'    |       |           |         |            |
'    |       |           |         +---u,v steps+---proption
'    |       |           +---lenth of axis
'    |       +---Origin
'    +---which surface used in FunctionX,FunctionY and FunctionZ
DATA "Second,a ball(R=10)"
DATA "Function:x=10*sin(u)*cos(v),y=10*sin(u)*sin(v),z=10*cos(v)"
DATA "Range   :u from 0 to PI and v from 0 to 2PI"
DATA 2,400,300,150,150,150,20,20,10,10,10,0,3.141593,0,6.283185

DATA "Third,a drop"
DATA "Function:x=sin(u)*cos(v)*cos(u)^2,y=cos(u),z=sin(u)*sin(v)*cos(u)^2"
DATA "Range   :u from 0 to PI and v from 0 to 2PI"
DATA 3,320,270,250,250,200,30,30,200,200,200,0,3.141593,0,6.283185

DATA "Rolate drop by changing expressions"
DATA "Function:x=cos(u),y=sin(u)*cos(v)*cos(u)^2,z=sin(u)*sin(v)*cos(u)^2"
DATA "Range   :u from 0 to PI and v from 0 to 2PI"
DATA 4,320,270,250,250,200,30,30,200,200,200,0,3.141593,0,6.283185

DATA "Next,noname"
DATA "Function:x=u,y=v,z=sin(u*u+v*v)/sqr(u*u+v*v)"
DATA "Range   :u from -1 to 1 and v from -3 to 3"
DATA 5,320,270,250,250,200,40,40,60,60,60,-3,3,-3,3

DATA "Resize noname by Sub SetProportion"
DATA "Function:x=u,y=v,z=sin(u*u+v*v)/sqr(u*u+v*v)"
DATA "Range   :u from -1 to 1 and v from -3 to 3"
DATA 5,320,270,250,250,200,40,40,60,60,20,-3,3,-3,3

'
'Description:delay until press a key.
'
SUB Delay
  DO UNTIL (INKEY$ <> "")
  LOOP
END SUB

'
'Description:drawing axis.
'Input   :
'         XLenth:   The lenth of x-axis
'
'
SUB DrawAxis (XLenth AS INTEGER, YLenth AS INTEGER, ZLenth AS INTEGER)
  SHARED Origin AS OriginLocation
  DrawKent Origin.Hor, Origin.Ver, Origin.Hor, Origin.Ver - ZLenth, 8
  DrawKent Origin.Hor, Origin.Ver, Origin.Hor + INT(YLenth * SQR(3) * .5), Origin.Ver + INT(YLenth * .5), 8
  DrawKent Origin.Hor, Origin.Ver, Origin.Hor - INT(XLenth * SQR(3) * .5), Origin.Ver + INT(XLenth * .5), 8
END SUB

'
'Description:drawing a kent.
'Input:
'      (x1,y1)  the coordinate begin
'      (x2,y2)  the coordinate end
'      Angle    a angle that splayed
'
SUB DrawKent (x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER, Angle AS SINGLE)
  xn = (x1 - x2) / (SQR((x1 - x2) ^ 2 + (y1 - y2) ^ 2))
  yn = (y1 - y2) / (SQR((x1 - x2) ^ 2 + (y1 - y2) ^ 2))
  x = 12 * xn
  y = 12 * yn
  Angle = ATN(1) * 4 / 180 * Angle
  cosine = COS(Angle)
  sine = SIN(Angle)
  LINE (x1, y1)-(x2, y2)
  LINE (x2, y2)-(x * cosine - y * sine + x2, x * sine + y * cosine + y2)
  LINE (x2, y2)-(x * cosine - y * -sine + x2, x * -sine + y * cosine + y2)
END SUB

'
'Description:drawing surface,core
'Input   :
'         U1:u begin at
'         U2:u end in
'         V1:v begin at
'         V2:v end in
'
SUB DrawSurface (U1 AS SINGLE, U2 AS SINGLE, V1 AS SINGLE, V2 AS SINGLE)
  DIM UStep, VStep AS SINGLE
  DIM u, v AS SINGLE
  DIM x, y, z AS DOUBLE
  SHARED Origin AS OriginLocation
  SHARED k AS Proportion
  SHARED UDivideN, VDivideN AS INTEGER
  SHARED FunN AS INTEGER
  UStep = (U2 - U1) / UDivideN
  VStep = (V2 - V1) / VDivideN
  DIM PinMonitor(0 TO UDivideN, 0 TO VDivideN) AS Coordinate

  u = U1
  FOR UCount = 0 TO UDivideN
    v = V1
    FOR Vcount = 0 TO VDivideN
      x = FunctionX(u, v) * k.xk
      y = FunctionY(u, v) * k.yk
      z = FunctionZ(u, v) * k.zk
'  The codes below is another form of projection.
'  PinMonitor(UCount, Vcount).x = y - x / (2 * SQR(2)) + Origin.Hor
'  PinMonitor(UCount, Vcount).y = -(z - x / (2 * SQR(2))) + Origin.Ver
      PinMonitor(UCount, Vcount).x = y * SQR(3) * .5 - x * SQR(3) * .5 + Origin.Hor
      PinMonitor(UCount, Vcount).y = -(z - y * .5 - x * .5) + Origin.Ver
      v = v + VStep
    NEXT Vcount
    u = u + UStep
  NEXT UCount
                     
  FOR Vcount = 1 TO VDivideN
    LINE (PinMonitor(0, Vcount).x, PinMonitor(0, Vcount).y)-(PinMonitor(0, Vcount - 1).x, PinMonitor(0, Vcount - 1).y)
  NEXT Vcount

  FOR UCount = 1 TO UDivideN
    LINE (PinMonitor(UCount, 0).x, PinMonitor(UCount, 0).y)-(PinMonitor(UCount - 1, 0).x, PinMonitor(UCount - 1, 0).y)
    FOR Vcount = 1 TO VDivideN
      LINE (PinMonitor(UCount, Vcount).x, PinMonitor(UCount, Vcount).y)-(PinMonitor(UCount - 1, Vcount).x, PinMonitor(UCount - 1, Vcount).y)
      LINE (PinMonitor(UCount, Vcount).x, PinMonitor(UCount, Vcount).y)-(PinMonitor(UCount, Vcount - 1).x, PinMonitor(UCount, Vcount - 1).y)
    NEXT Vcount
  NEXT UCount

END SUB

'
'Description:caculating x.Modified it to show other surface.
'Input      :
'            u:a paramete
'            v:another paramete
'
FUNCTION FunctionX (u AS SINGLE, v AS SINGLE)
  SHARED FunN AS INTEGER
  SELECT CASE FunN
    CASE 1
      FunctionX = u
    CASE 2
      FunctionX = 10 * SIN(u) * COS(v)
    CASE 3
      FunctionX = SIN(u) * COS(v) * COS(u) ^ 2
    CASE 4
      FunctionX = COS(u)
    CASE 5
      FunctionX = u
    CASE ELSE
      FunctionX = 0
  END SELECT
END FUNCTION

'
'Description:caculating y.Modified it to show other surface.
'Input      :
'            the same as FuctionX
'
FUNCTION FunctionY (u AS SINGLE, v AS SINGLE)
  SHARED FunN AS INTEGER
  SELECT CASE FunN
    CASE 1
      FunctionY = v
    CASE 2
      FunctionY = 10 * SIN(u) * SIN(v)
    CASE 3
      FunctionY = COS(u)
    CASE 4
      FunctionY = SIN(u) * COS(v) * COS(u) ^ 2
    CASE 5
      FunctionY = v
    CASE ELSE
      FunctionY = 0
  END SELECT
END FUNCTION

'
'Description:caculating z.Modified it to show other surface.
'Input      :
'            the same as FunctionX
'
FUNCTION FunctionZ (u AS SINGLE, v AS SINGLE)
  SHARED FunN AS INTEGER
  SELECT CASE FunN
    CASE 1
      FunctionZ = 0
    CASE 2
      FunctionZ = 10 * COS(u)
    CASE 3
      FunctionZ = SIN(u) * SIN(v) * COS(u) ^ 2
    CASE 4
      FunctionZ = SIN(u) * SIN(v) * COS(u) ^ 2
    CASE 5
      FunctionZ = SIN(u * u + v * v) / SQR(u * u + v * v)
    CASE ELSE
      FunctionZ = 0
  END SELECT
END FUNCTION

'
'Description:put a string to x,y.
'
SUB PrintText (x AS INTEGER, y AS INTEGER, str AS STRING)
  LOCATE x, y, 0
  PRINT str
END SUB

'
'Description:assign the UDivideN and VDivideN.
'Input      :
'            N1:how many parts u should be divided
'            N2:how many parts v should be divided
'
SUB SetDivideN (n1 AS INTEGER, n2 AS INTEGER)
  SHARED UDivideN, VDivideN AS INTEGER
  UDivideN = n1
  VDivideN = n2
END SUB

'
'Description:set the coordinates of origin.
'Input      :
'            Hor:the x-coordinate of origin
'            Ver:the y-coordinate of origin
'
SUB SetOrigin (Hor AS INTEGER, Ver AS INTEGER)
SHARED Origin AS OriginLocation
  Origin.Hor = Hor
  Origin.Ver = Ver
END SUB

'
'Description:set the size of surface showed on the screen.
'Input      :
'            X:show 1 (real number) stands how many pixels in x-component
'            Y:show 1 (real number) stands how many pixels in y-component
'            Z:show 1 (real number) stands how many pixels in z-component
'
SUB SetProportion (x AS SINGLE, y AS SINGLE, z AS SINGLE)
  SHARED k AS Proportion
  k.xk = x
  k.yk = y
  k.zk = z
END SUB


